<script>
    import { layout } from "../svelte_stores/layout_store";
    import {
        Label,
        Input,
        NumberInput,
        Radio,
        Select,
        Toggle,
        Helper,
    } from "flowbite-svelte";

    import RangeWithNumberInput from "../form_components/RangeWithNumberInput.svelte";

    export let i_subplot;

    let y_axis_scale = ["linear", "log10", "polar_lat_annot"];
    let y_axis_scale_labels = {
        linear: "Linear",
        log10: "Base-10 logarithmic",
        polar_lat_annot: "Remap polar-crossing latitudes",
    };
    let axis_annotation = ["hidden", "visible"];
</script>

<div class="flex flex-col gap-3">
    <h2>Labels and legend</h2>
    <Label
        >Title:
        <Input bind:value={$layout.subplots[i_subplot].title} />
    </Label>

    <Label
        >Y-axis label:
        <Input bind:value={$layout.subplots[i_subplot].y_label} />
    </Label>

    <Label
        >Show legend:
        <Toggle bind:checked={$layout.subplots[i_subplot].legend_visible}
            >Show legend</Toggle>
    </Label>

    <h2>Y-axis bounds</h2>
    <Label
        >Mirror min and max bounds around zero
        <Toggle bind:checked={$layout.subplots[i_subplot].ydomain.mirror} />
    </Label>
    <div class="flex flex-row gap-5">
        {#if !$layout.subplots[i_subplot].ydomain?.mirror}
            <Label
                >Overall y-axis minimum
                <Input
                    bind:value={$layout.subplots[i_subplot].ydomain
                        .bounds[0]} />
            </Label>
        {/if}
        <Label
            >Overall y-axis maximum
            <NumberInput
                bind:value={$layout.subplots[i_subplot].ydomain.bounds[1]}
                on:change={() => {
                    if ($layout.subplots[i_subplot].ydomain.mirror) {
                        $layout.subplots[i_subplot].ydomain.bounds[0] =
                            -1 * $layout.subplots[i_subplot].ydomain.bounds[1];
                    }
                }} />
        </Label>
    </div>

    <Label
        >Trim Y-axis minimum and maximum
        {#if $layout.subplots[i_subplot].scale == "log10"}
            <Helper
                >Because the logarithmic scale is selected above, these bounds
                are specified in terms of their base-10 exponents</Helper>
        {/if}
        {#if $layout.subplots[i_subplot].ydomain?.mirror}
            <RangeWithNumberInput
                min={0}
                max={$layout.subplots[i_subplot].ydomain.bounds[1]}
                bind:value={$layout.subplots[i_subplot].ydomain.default[1]}
                on:change={() => {
                    if ($layout.subplots[i_subplot].ydomain.mirror) {
                        $layout.subplots[i_subplot].ydomain.default[0] =
                            -1 * $layout.subplots[i_subplot].ydomain.default[1];
                    }
                }} />
        {:else}
            <RangeWithNumberInput
                min={$layout.subplots[i_subplot].ydomain.bounds[0]}
                max={$layout.subplots[i_subplot].ydomain.bounds[1]}
                bind:value={$layout.subplots[i_subplot].ydomain.default[0]} />
            <RangeWithNumberInput
                min={$layout.subplots[i_subplot].ydomain.bounds[0]}
                max={$layout.subplots[i_subplot].ydomain.bounds[1]}
                bind:value={$layout.subplots[i_subplot].ydomain.default[1]} />
        {/if}
    </Label>

    <h2>Axis tick annotations</h2>
    <Label
        >Axis tick text annotations
        <div class="flex flex-col gap-1">
            <Toggle
                size="small"
                checked={$layout.subplots[i_subplot].xaxis_annotation ==
                    "visible"}
                on:change={(e) => {
                    $layout.subplots[i_subplot].xaxis_annotation = e.target
                        .checked
                        ? "visible"
                        : "hidden";
                    // Increase bottom margin, if necessary to fit the tick mark annotation
                    if (
                        e.target.checked &&
                        $layout.subplots[i_subplot].margins.bottom < 30
                    ) {
                        $layout.subplots[i_subplot].margins.bottom = 30;
                    }
                }}>
                X-axis
            </Toggle>
            <Toggle
                size="small"
                checked={$layout.subplots[i_subplot].yaxis_annotation ==
                    "visible"}
                on:change={(e) => {
                    $layout.subplots[i_subplot].yaxis_annotation = e.target
                        .checked
                        ? "visible"
                        : "hidden";
                }}>
                Y-axis
            </Toggle>
        </div>
    </Label>

    <h2>Y-axis options</h2>
    <Label
        >Tick spacing:
        <RangeWithNumberInput
            min={1}
            max={100}
            step={1}
            bind:value={$layout.subplots[i_subplot].tick_spacing} />
    </Label>

    <Label
        >Y-axis scale type:
        {#each y_axis_scale as scale_type}
            <Radio
                name="scale"
                bind:group={$layout.subplots[i_subplot].scale}
                value={scale_type}>
                {y_axis_scale_labels[scale_type]}
            </Radio>
        {/each}
    </Label>
    <!-- <Toggle size="small" bind:checked={$layout.subplots[i_subplot].ydomain.mirror}>Y-axis bounds mirrored around zero</Toggle> -->

    <Label
        >Y-axis tick format:
        <Select bind:value={$layout.subplots[i_subplot].ytick_format}>
            <option value="auto">Automatic</option>
            <option value="d">Integer</option>
            <option value=".1f">One decimal place</option>
            <option value=".2f">Two decimal places</option>
        </Select>
    </Label>
</div>
